package gsmAlarm;

import java.io.*;
import javax.microedition.io.Connector;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;
import com.siemens.icm.io.file.*;

/**
 *      -.
 *      Enter,  
 *   ,  .
 * @author dvk
 *
 */

public class MenuSettings extends Thread 
{
	//  ,       
	Tc65SerialPort 	tc65SerialPort;
	ATCommand 		atCommand;
	SMSSendReceive 	smsSendReceive;
	
	//     
	public static final char MS_TIMEOUT 	= 65535; //  : 
	public static final char MS_NODATA 	= 0;  //   ProcessMenu,   .
	
	public static final int MS_SENDTESTSMS = 3;
	//  ProcessMenu() -  -  
	public static final int MS_HAVEATCMD= 2;  
	public static final int MS_EXITPROG	= 1; //  ProcessMenu() -    
	public static final int MS_DONTEXIT	= 0; 

	//    
	int MenuTimeout = 0;
	int CurrMenu = 0; //    (0 -  )
	
	//  
	String Number1/* = "Not set"*/; //   
	int DelayArmed = 10; //    
	int DelayAfterDoorOpen = 10; //     
	int DelayRearm = 20; //     
	String PINCode/* = "0000"*/; //   
	boolean sendSMSOnReboot = true; //     
	boolean DebugInfoToCOM = false; //   .  -
	
	boolean FillingBuffer = false; //   -    ENTER
	//char InputBuffer[]; //     
	StringBuffer strBuf; //     
	int idxInputBuffer = 0; //      
	int NowFillingValue = 0; //  ,      

	// -,   ,  ProcessMenu()  MS_HAVEATCMD
	String atCmd2Execute;
	
	public MenuSettings(Tc65SerialPort tc65SerialPort, ATCommand atCommand)
	{
		this.tc65SerialPort = tc65SerialPort;
		this.atCommand = atCommand;
		
		strBuf = new StringBuffer(40);
		atCmd2Execute = new String();
		Number1 = new String("(not set)");
		PINCode = new String("0000");
	}
	
	public void run() 
	{
		LoadFromFile();
		try 
		{
			do
			{
				sleep(50);
				int ch;
				if(tc65SerialPort.hasData() > 0)
				{
				    ch = tc65SerialPort.readByte();
				    if (ch >= 0) 
				    {
				    	int retcode = ProcessMenu((char)ch);
				    	
				    	if(retcode == MS_EXITPROG)
				    	{
				    		DebugOut("\nClosing MenuSettings thread.");
					    	close();
					    	break;
				    	}
				    	else
				    	{
				    		if(retcode == MS_HAVEATCMD)
				    		{
				    			try {
				    				DebugOut(atCommand.send(atCmd2Execute));
								} catch (IllegalStateException e) {
									e.printStackTrace();
								} catch (IllegalArgumentException e) {
									e.printStackTrace();
								} catch (ATCommandFailedException e) {
									e.printStackTrace();
								}
				    		}
				    		else if(retcode == MS_SENDTESTSMS)
				    		{
				    			if(Number1.charAt(0) == '+' || Number1.charAt(0) == '8')
				    				smsSendReceive.sendSMS(Number1, "   -  SMS");
				    		}
				    			
				    	}
				    }
				}
				else //      
					ProcessMenu(MS_NODATA);
				
				//     
				if(MenuTimeout >= 30)
				{
					if(MenuTimeout == 30)
						ProcessMenu(MS_TIMEOUT);
					if(MenuTimeout >= 100)
						MenuTimeout = 31;
					CurrMenu = 0; //  
				}
				
			}
			while(true);
		} 
		catch (InterruptedException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
			DebugOut("InterruptedException, closing MenuSettings thread");
			close();
		}
	}
	
	public void close()
	{
		//  ,     - - 
		//    .
		DebugOut("\n\rGSM alarm application finished\n\r");
	}
/**
 *   -   (       - 0)
 *  1 -   
 *  2 -  
 *  	1 -    
 *  	2 -     
 *  	3 -   
 *  	4 -      
 *  	5 -  PIN-
 *  	6 -  SMS  
 *  	8 -    
 *  	D -     - 
 *  	0 -   
 *  8 - -
 *  	1 -  GPIO0 = 1
 *  	2 -  GPIO0 = 0
 *  	3 -  GPIO1 = 1
 *  	4 -  GPIO1 = 0
 *  	9 -  SMS
 *  	0 -   
 *  9 -   
 *  0 -   

 * @param NextEntered
 * @return
 */
	int ProcessMenu(char NextEntered)
	{
		boolean StopProcessing = false; //   false,    .
		int retval = MS_DONTEXIT; //  
		
		if(NextEntered == MS_NODATA) //    
		{
			StopProcessing = true;
			//    
		}
		
		while(StopProcessing == false)
		{
			StopProcessing = true;
			MenuTimeout = 0; //  ,  - 
			switch(CurrMenu)
			{
			// ******************* Menu 0-0 ******************
			case 0: //   
				if(NextEntered == 0x0d) //  Enter
				{
					CurrMenu = 1; //    1    Enter
					StopProcessing = false;
				}
				break;
			// ******************* Menu 0-1 ******************
			case 1: //    
				switch(NextEntered)
				{
				case '1': //"1 -  \n\r" 
					DisplaySettings();
					break;
				case '2': //"2 -  \n\r"
					CurrMenu = 12;
					StopProcessing = false; //   . 
					NextEntered = 0x0d; //   ENTER
					break;
				case '6': //"6 - try current PIN\n\r"
					CurrMenu = 6;
					StopProcessing = false; //   . 
					NextEntered = 0x0d; //   ENTER
					break;
				case '8': //"8 - test menu\n\r"
					CurrMenu = 8;
					StopProcessing = false; //   . 
					NextEntered = 0x0d; //   ENTER
					break;
				case '9': //"9 -   \n\r"
					CurrMenu = 9;
					tc65SerialPort.serialOut("ARE YOU SURE? Press \"6\" to confirm.\n\r");
					break;
				case '0': //"0 -   \n\r"
					break;
				case 0x0d: // Enter
					tc65SerialPort.serialOut(	"GSM alarm menu\n\r" +
							"-----------------\n\r" +
							"1 - Display settings\n\r" +
							"2 - Change settings\n\r" +
							"6 - PIN menu\n\r" +
							"8 - Test menu\n\r" +
							"9 - Exit Java APPLICATION\n\r" +
							"0 - Exit menu\n\r\n\r");
					break;
				default:
					tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n");					
					break;
				}

				break;
				// ******************* Menu 0-6 ******************
			case 6:
				switch(NextEntered)
				{
				case '1': //1 - Enter current PIN
					//    PIN,  ,
					//       3,   
					// .
					atCmd2Execute = "AT+CPIN=" + PINCode + "\r";
					retval = MS_HAVEATCMD;
					break;
				case '0': //"0 -   \n\r"
					CurrMenu = 1; //    
					NextEntered = 0x0d;
					StopProcessing = false;
					break;
				case 0x0d: // Enter
					tc65SerialPort.serialOut(	"PIN menu\n\r" +
							"-----------------------------------------------------------------\n\r" +
							"- ATTENTION. Please use this menu ONLY if your current PIN code -\n\r" +
							"- is NOT accepted. To change PIN code press 0, 2, 5.            -\n\r" +
							"- IMPORTANT. After entering correct PIN code please save it in  -\n\r" +
							"- local file system (press 0, 2, 9).                            -\n\r" +
							"-----------------------------------------------------------------\n\r" +
							"Current PIN is: " + PINCode + "\n\r\n\r" +
							"1 - Enter current PIN\n\r" +
							"0 - Exit menu\n\r\n\r");
					break;
				default:
					tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n");					
					break;
				}
				break;
			// ******************* Menu 0-8 ******************
			case 8:
				switch(NextEntered)
				{
				case '1': //1 - Set GPIO0=1 
					atCmd2Execute = "AT^SSIO=0,1\r";
					retval = MS_HAVEATCMD;
					break;
				case '2': //2 - Set GPIO0=0
					atCmd2Execute = "AT^SSIO=0,0\r";
					retval = MS_HAVEATCMD;
					break;
				case '3': //3 - Set GPIO1=1
					atCmd2Execute = "AT^SSIO=1,1\r";
					retval = MS_HAVEATCMD;
					break;
				case '4': //4 - Set GPIO1=0
					atCmd2Execute = "AT^SSIO=1,0\r";
					retval = MS_HAVEATCMD;
					break;
				case '9': //9 - Send est SMS
					retval = MS_SENDTESTSMS;
					break;
				case '0': //"0 -   \n\r"
					CurrMenu = 1; //    
					NextEntered = 0x0d;
					StopProcessing = false;
					break;
				case 0x0d: // Enter
					tc65SerialPort.serialOut(	"Test menu\n\r" +
							"-----------------\n\r" +
							"1 - Set GPIO0=1\n\r" +
							"2 - Set GPIO0=0\n\r" +
							"3 - Set GPIO1=1\n\r" +
							"4 - Set GPIO1=0\n\r" +
							"9 - Send test SMS to "+Number1+"\n\r" +
							"0 - Exit menu\n\r\n\r");
					break;
				default:
					tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n");					
					break;
				}
				break;
			// ******************* Menu 0-9 ******************
			case 9: //     
				if(NextEntered == '6') //  
					return MS_EXITPROG;
				else
					CurrMenu = 1; //   .
				break;

			// ******************* Menu 1-2 ******************
				
			case 12:
				//     
				if(FillingBuffer)
				{
					//    
					if(NextEntered > ' ')
					{
						if(idxInputBuffer < 39) //      1
						{
							//InputBuffer[idxInputBuffer] = NextEntered;
							strBuf.append(NextEntered);
							idxInputBuffer++;
							//ByteArrayInputStream bais = new ByteArrayInputStream(InputBuffer); 
							tc65SerialPort.serialOut(NextEntered);
						}
						else //   ,  
						{
							FillingBuffer = false;
							//InputBuffer[idxInputBuffer] = 0;
							NextEntered = 0x0d; //   
						}
					}
					else //    ENTER
					{
						FillingBuffer = false;
						//InputBuffer[idxInputBuffer] = 0;
						NextEntered = 0x0d; //   

						tc65SerialPort.serialOut("\n\rDEBUG: Entered " + /*InputBuffer.toString()*/ strBuf.toString() + "\n\r");
						//    ,  
						switch(NowFillingValue)
						{
						case 1: // 
							if(idxInputBuffer > 0)
								Number1 = /*InputBuffer.*/strBuf.toString();
							tc65SerialPort.serialOut("\n\rNew telephone number: " + Number1 + "\n\r");
							break;
						case 2:
							if(idxInputBuffer > 0)
								DelayArmed = Integer.valueOf(/*InputBuffer.*/strBuf.toString(), 10).intValue();
							tc65SerialPort.serialOut("\n\rNew delay before armed state: " + DelayArmed + "\n\r");
							break;
						case 3:
							if(idxInputBuffer > 0)
								DelayAfterDoorOpen = Integer.valueOf(/*InputBuffer*/strBuf.toString(), 10).intValue();
							tc65SerialPort.serialOut("\n\rNew alarm delay after door open: " + 
									DelayAfterDoorOpen + "\n\r");
							break;
						case 4:
							tc65SerialPort.serialOut("\n\rNew re-arm delay: " + DelayRearm + "\n\r");
							if(idxInputBuffer > 0)
								DelayRearm = Integer.valueOf(/*InputBuffer*/strBuf.toString(), 10).intValue();
							tc65SerialPort.serialOut("\n\rNew re-arm delay: " + DelayRearm + "\n\r");
							break;
						case 5: // PIN
							if(idxInputBuffer > 0)
								PINCode = /*InputBuffer.*/strBuf.toString();
							tc65SerialPort.serialOut("\n\rNew PIN code: " + PINCode + "\n\r");
							break;
						}
					}
				}
				
				if(FillingBuffer == false)
				{
					idxInputBuffer = 0; // -   ... 
					switch(NextEntered)
					{
					case 0x0d:
						tc65SerialPort.serialOut(	"\n\rChange settings menu\n\r" +
								"-----------------\n\r" +
								"1 - Change telephone number\n\r" +
								"2 - Change delay before armed state\n\r" +
								"3 - Change alarm delay after door open\n\r" +
								"4 - Change re-arm delay\n\r" +
								"5 - Change PIN code\n\r" +
								"6 - Send SMS on reboot\n\r" +
								"8 - Save settings to file\n\r" +
								"D - Show debug info in terminal\n\r" +
								"0 - Exit menu\n\r\n\r");
						break;
					case '1':
						NowFillingValue = 1;
						FillingBuffer = true;
						tc65SerialPort.serialOut("\n\rChange telephone number\n\r" +
									 "-----------------------\n\r" +
								"Current telephone number:" + Number1 + 
								"\n\rEnter new telephone number:\n\r");
						break;
					case '2':
						NowFillingValue = 2;
						FillingBuffer = true;
						tc65SerialPort.serialOut("\n\rChange delay before armed state\n\r" +
									 "-------------------------------\n\r" +
								"Current delay before armed state:" + DelayArmed + 
						"\n\rEnter new delay before armed state:\n\r");
						break;
					case '3':
						NowFillingValue = 3;
						FillingBuffer = true;
						tc65SerialPort.serialOut("\n\rChange alarm delay after door open\n\r" +
									 "----------------------------------\n\r" +
								"Current alarm delay after door open:" + DelayAfterDoorOpen + 
						"\n\rEnter new alarm delay after door open:\n\r");
						break;
					case '4':
						NowFillingValue = 4;
						FillingBuffer = true;
						tc65SerialPort.serialOut("\n\rChange re-arm delay\n\r" +
									 "-------------------\n\r" +
								"Current re-arm delay:" + DelayRearm + 
						"\n\rEnter new re-arm delay:\n\r");
						break;
					case '5':
						NowFillingValue = 5;
						FillingBuffer = true;
						tc65SerialPort.serialOut("\n\rChange PIN code\n\r" +
									 "-------------------\n\r" +
								"Current PIN code:" + PINCode + 
						"\n\rEnter new PIN code:\n\r");
						break;
					case '6':
						sendSMSOnReboot = !sendSMSOnReboot;
						tc65SerialPort.serialOut("\n\rSend SMS on reboot\n\r" +
									 "-------------------\n\r" +
								"Send SMS on reboot = " + sendSMSOnReboot + 
						"\n\r");
						break;
					case '8':
						tc65SerialPort.serialOut("\n\rSave settings to file\n\r" +
									 "---------------------\n\r");
						SaveToFile();
						break;
					case 'D': case 'd':
						DebugInfoToCOM = !DebugInfoToCOM;
						tc65SerialPort.serialOut("\n\rShow debug info in terminal\n\r" +
									 "-------------------\n\r" +
								"Show debug info = " + DebugInfoToCOM + 
						"\n\r");
						break;
					case '0':
						CurrMenu = 1; //    
						NextEntered = 0x0d;
						StopProcessing = false;
						break;
					default:
						tc65SerialPort.serialOut("Unknown command! Press Enter to display menu.\r\n\n\r");					
						break;
					}
					//    ?
					if(FillingBuffer == true)
						strBuf.delete(0, strBuf.length());
						
				} // else if(FillingBuffer)
				break;
			// ******************* default ******************
			default: //   
				tc65SerialPort.serialOut("ERROR! Bad CurrMenu value.\n\r");
				CurrMenu = 0; 
				NextEntered = MS_NODATA;
				break;
			}
		}

		return retval;
	}

/**
 *    
 *
 */	
	void DisplaySettings()
	{
		tc65SerialPort.serialOut(	"GSM alarm settings\n\r" +
				"-----------------\n\r" +
				"Telephone number: " + Number1 + "\n\r" +
				"Delay before armed state: " + DelayArmed + "\n\r" +
				"Alarm delay after door open: " + DelayAfterDoorOpen + "\n\r" +
				"Re-arm delay: " + DelayRearm + "\n\r" +
				"Show debug info: " + DebugInfoToCOM + "\n\r" +
				"Send SMS on reboot: " + sendSMSOnReboot + "\n\r" +
				"PIN code: " + PINCode + "\n\r\n\r");
	}

/**
 *    
 */
	void LoadFromFile()
	{
		try 
		{
			FileConnection fconn = (FileConnection)Connector.open("file:///a:/gsmalarm.dat", 
					Connector.READ);
			// If no exception is thrown, then the URI is valid, but the file may or may not exist.
			if (fconn.exists())
			{
				long size = fconn.fileSize();
				DebugOut("\n\rgsmalarm.dat filesize="+size+"\n\r");
				if(size > 30 && size < 38)
				{
					DataInputStream dis = fconn.openDataInputStream();
					DelayAfterDoorOpen = dis.readInt();
					DelayArmed = dis.readInt();
					DelayRearm = dis.readInt();
					Number1 = dis.readUTF();
					PINCode = dis.readUTF();
					sendSMSOnReboot = dis.readBoolean();
					DebugInfoToCOM = dis.readBoolean();
//					serialOut("DEBUG: Number1="+Number1 +"\n\r");
				}
				else
					tc65SerialPort.serialOut("Probably wrong contents of settings file; using defaults\n\r");
			}
			else
				tc65SerialPort.serialOut("Settings file not found; using defaults\n\r");

			fconn.close();
		}
		catch (IOException ioe) 
		{
			tc65SerialPort.serialOut("File read operation error: " + ioe.getMessage() + "\n\r");
		}
	}

	/**
	 *    
	 */
	void SaveToFile()
	{
		try 
		{
			FileConnection fconn = (FileConnection)Connector.open("file:///a:/gsmalarm.dat");
			// If no exception is thrown, then the URI is valid, but the file may or may not exist.
			
			if (!fconn.exists())
			{
				fconn.create();  // create the file if it doesn't exist
			}

			if (fconn.exists())
			{
				fconn.truncate(0);
				DataOutputStream dos = fconn.openDataOutputStream();
				dos.writeInt(DelayAfterDoorOpen);
				dos.writeInt(DelayArmed);
				dos.writeInt(DelayRearm);
				dos.writeUTF(Number1);
				dos.writeUTF(PINCode);
				dos.writeBoolean(sendSMSOnReboot);
				dos.writeBoolean(DebugInfoToCOM);
				tc65SerialPort.serialOut("\n\rThe \"gsmalarm.dat\" file has been saved to module file system\n\r");
			}
			else
				tc65SerialPort.serialOut("Could not create output file, settings not stored\n\r");
			
			fconn.close();
		}
		catch (IOException ioe) 
		{
			tc65SerialPort.serialOut("File write operation error: " + ioe.getMessage() + "\n\r");
		}
	}
	
	void DebugOut(String strMsg)
	{
		if(DebugInfoToCOM)
			tc65SerialPort.serialOut(strMsg);
	}
}

