package gsmAlarm;

import javax.microedition.io.ServerSocketConnection;

import com.siemens.icm.io.ATCommand;
import com.siemens.icm.io.ATCommandFailedException;

public class Tc65Io {
	ATCommand		atCommand;
	MenuSettings menuSettings;
	boolean InputValue[];  //   
	boolean InputActiveLevel[];  //     -
	//   .
	
//  ,       
//     . ,     
//   . 
	int InputChanged[];  
	
	boolean constructOk = false;
	
	public Tc65Io(ATCommand atCommand, MenuSettings menuSettings)
	{
		//    -,     
        try 
        {
			this.atCommand = atCommand;// */ new ATCommand(false);
			constructOk = true;
		} 
        catch (IllegalStateException e) 
        {
			constructOk = false;
		} 
/*        catch (ATCommandFailedException e) 
		{
			constructOk = false;
		}*/

		this.menuSettings = menuSettings; //for debug

        InputChanged = new int[10];
        InputValue = new boolean[10];
        InputActiveLevel = new boolean[10];
        for(int i=0; i<10; i++)
        	InputActiveLevel[i] = false; 
        InputActiveLevel[3] = true; //    -  
        InputActiveLevel[4] = true; //    -  
        
//        constructOk = true;
        if(constructOk == false)
        	menuSettings.DebugOut("ERROR initializing Tc65Io!\n\r");
	}

	/**
	 *   -
	 *
	 */
	public boolean initIo()
	{
		boolean bRet = constructOk; //    -   -   .
		
		try
		{
			menuSettings.DebugOut(atCommand.send("AT^SPIO=0\r")); //   I/O
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SPIO=1\r")); //   I/O
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,0,1,0\r")); // . GPIO1, out, init_state=0 
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,1,1,0\r")); // . GPIO2, out, init_state=0 
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,2,0\r")); //   . GPIO3, input 
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,2\r")); //   .  GPIO3  
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,3,0\r")); //   . GPIO4, input 
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,3\r")); //   .  GPIO4  
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,4,0\r")); //   . GPIO5, input 
			Thread.sleep(200);
			menuSettings.DebugOut(atCommand.send("AT^SCPOL=1,4\r")); //   .  GPIO5  
			Thread.sleep(200);
			//  GPIO6   
			menuSettings.DebugOut(atCommand.send("AT^SCPIN=1,5,1,1\r")); //   . GPIO6, output 
			Thread.sleep(200);
			//     ERROR.
			//			DebugOut("I/O initialized\n\r");
		}
		catch(ATCommandFailedException e)
		{
			menuSettings.DebugOut("ERROR: I/O init failed\n\r");
//			DebugOut(e.getMessage());
			bRet = false;
		}
		catch(InterruptedException e)
		{
			menuSettings.DebugOut("ERROR: I/O init failed\n\r");
//			DebugOut(e.getMessage());
			bRet = false;
		}
		return bRet;
	}
	
	/**
	 *   .     
	 *     5-10 ,    
	 *  AT^SCPOL
	 */
	public void RefreshInputs()
	{
		for(int i=2; i<5; i++)
		{
			boolean in = inIo(i); 
			if(InputValue[i] != in)
			{
				InputValue[i] = in;
				InputChanged[i]++;
			}
//			menuSettings.DebugOut(in?"1":"0");
		}
	}
	
/**
 *   ATCommandListener,    ^SCPOL:
 * @param pol
 */	
	public void OnReceiveSCPOL(String pol)
	{
		menuSettings.DebugOut(pol);
		int pos = pol.indexOf("^SCPOL:");
		if(pos != -1)
		{
			pos += 7; //   ":"
			int pos2 = pol.indexOf(",", pos); //  
			if(pos2 == -1)
				return; //  
			int input = pol.charAt(pos2-1) - '0'; //0-9
			int state = pol.charAt(pos2+1) - '0'; // 0  1
			if(0 < input && input < 10)
			{
				boolean in = (state == 1); 
//		        menuSettings.DebugOut("i" + input + " " + state + "/i ");
				
//				menuSettings.DebugOut("v" + InputValue[input] + " " + in + "/v ");

				if(InputValue[input] != in)
				{
					InputValue[input] = in;
					// ,   ____ 
					if(InputValue[input] == InputActiveLevel[input])
					{
						InputChanged[input] = 1;
				        menuSettings.DebugOut("Changed:"+input+"\r\n");
					}
				}
			}
		}
	}
	
	public void closeIo()
	{
		try
		{
			menuSettings.DebugOut(atCommand.send("AT^SPIO=0\r")); //   I/O
			Thread.sleep(200);
		}
		catch(ATCommandFailedException e)
		{
			menuSettings.DebugOut("ERROR: I/O cleanup failed\n\r");
		}
		catch(InterruptedException e)
		{
			menuSettings.DebugOut("ERROR: I/O cleanup failed\n\r");
		}
	}

	/**
	 *  true,      
	 *     (  
	 *      InputActiveLevel[] ). 
	 */	
	public boolean GetChanged(int pin)
	{
		boolean changed = (InputChanged[pin] > 0);
		InputChanged[pin]=0;
		if(changed)
		{
			menuSettings.DebugOut("Changed=1@pin "+pin+"\n\r");
		}
		return changed;
	}

	/**
	 *     ,   
	 */	
	public void ResetAllInputs()
	{
        for(int i=0; i<10; i++)
        {
        	InputChanged[i] = 0;
        	// ,   -   
        	InputValue[i] = !InputActiveLevel[i];
        }
	}
	
	/**
	 *  1  0    
	 * @param pin    IO (0-9)
	 * @param value  true/false or zero/nonzero 
	 */
	boolean outIo(int pin, boolean value)
	{
		boolean bRet = true;
		try
		{
			//     ,     , ..  .
			/*menuSettings.DebugOut(*/atCommand.send("AT^SSIO="+pin+(value==false?",0\r":",1\r"))/*+"\r\n")*/; //   I/O
		}
		catch(ATCommandFailedException e)
		{
			bRet = false;
		}
	
		return bRet;
	}
	
	boolean outIo(int pin, int value)
	{
		return outIo(pin, (value==0)?false:true);
	}

	/**
	 *     
	 * @param pin    IO (0-9)
	 */
	boolean inIo(int pin)
	{
		boolean bRet = false;
		try
		{
			String str = atCommand.send("AT^SGIO="+pin+"\r"); //   I/O
			
//			menuSettings.DebugOut(str+"\n\r");
			
			int idx = str.indexOf("^SGIO:");
			if(idx > 0)
			{
				// "^SGIO: 0"
				char c = str.charAt(idx + 7);
				if(c == '1') // "^SGIO: 1"
					bRet = true;
			}
//			menuSettings.DebugOut(str);
		}
		catch(ATCommandFailedException e)
		{
			//DebugOut(e.getMessage());
			menuSettings.DebugOut("ATCommandFailedException");
			bRet = false;
		}
		return bRet;
	}
}
